% Sistema SEGWAY linearizzato

clear all

m=5;     % Massa del carico (kg)
M=10;    % Massa della ruota (kg)
g=9.8;   % Accelerazione di gravita' (m/s^2)
l=0.5;     % Lunghezza del manubrio (m)
rho=0.2; % Raggio della ruota (m)
mu=5;    % Coefficiente di attrito (Ns/m)

% matrici del sistema linearizzato
A=[ 0 1 0 ; g/l 0 2*mu/(l*M) ; 0 0 -2*mu/M ]
B=[ 0 ; -1/(m*l^2)*(1+2*m*l/(M*rho)) ; 2/(M*rho) ]
C=[ 1 0 0 ; 0 0 1 ]

sys=ss(A,B,C,0);

% state-feedback gain
K=-lqr(A,B,diag([ 100 10 500 ]),100)

eig(A+B*K)

% observer gain
L=lqr(A',C',diag([ 1000 1000 1000 ]),diag([ 10 10 ]))'

eig(A-L*C)

comp=reg(sys,-K,L);